/*
 * 
 * InSync -- Sync4j Module
 * Copyright (C) 2003-2004  Jason Barrie Morley
 * inertia@in7.co.uk  http://www.in7.co.uk
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * 
 * InSyncContactItem.java
 *
 * description
 *
 */
 
// Package.
package uk.co.in7.insync;

// Imports.
import uk.co.in7.versit.*;
import sync4j.framework.engine.SyncItem;
import sync4j.framework.engine.SyncItemKey;
import sync4j.framework.engine.SyncItemState;

// Class.
public class InSyncContactItem extends InSyncItem {
    
    // Constants.
    
    // Variables.
    private VCard vCard = new VCard();
    
    // Constructors.
    public InSyncContactItem() {
        
    }
    
    public InSyncContactItem( Object key ) {
        this( key, SyncItemState.UNKNOWN );
    }
    
    public InSyncContactItem( Object key, char state ) {
        this.key = new SyncItemKey( key );
        this.state = state;
    }
    
    // Accessors.
    
    // Comparators.
    
    public boolean equivalent( InSyncItem item ) {
        
        if ( getType() != item.getType() ) {
            return false;
        } else {
            return getVCard().equals( ( ( InSyncContactItem )item ).getVCard() );
        }
        
    }
        
    // Accessors for the internal vCard.
    
    public VCard getVCard() {
        return vCard;
    }
    
    public void setVCard( VCard card ) {
        vCard = card;
    }
    
    protected int getType() {
        return CONTACT;
    }
    
    // Internal Methods.
    
}
